// Feb 2014 - block game engine - code by Emperor Katax 
// items class
/*function DragItem (radius, color) {
  if (radius === undefined) { radius = 40; }
  if (color === undefined) { color = "#aaa"; }*/ // test

function DragItem (imageFile, imageCoord, id) {
		//if (radius === undefined) { radius = 40; }
		//if (color === undefined) { color = "#aaa"; }
		// coordinations
		this.x = 0;					// current x
		this.y = 0;					// current y
		this.first_x = 0;		// default pos x
		this.first_y = 0;		// default pos y
		this.win_x = 0;			// win pos x
		this.win_y = 0;			// win pos y
		this.id = id;				// id number
		this.radius = 20;		// sensitive point to pick
		this.match = 52;		// sensitive point on match
		this.distanceX = 0;
		this.distanceY = 0;
		//
		this.vx = 0;
		this.vy = 0;
		this.rotation = 0;
		this.scaleX = 1;
		this.scaleY = 1;
		this.color = utils.parseColor("#33a");
		this.lineWidth = 2;
		this.name = "Image Item";
		//  image file
		this.image = new Image();
		this.image.src = imageFile;
		// image coordination as correct place
		this.coord = imageCoord[id];
		this.destX = 0;				// destination X
		this.destY = 0;				// destination Y
		this.fixed = false;	// fix drag item position on correct move by player
  
}
// add image and circle to stage
DragItem.prototype.draw = function (context) {
		context.drawImage(this.image, this.x, this.y);
		/*context.save();
		context.translate(this.x, this.y);
		context.rotate(this.rotation);
		context.scale(this.scaleX, this.scaleY);
		context.lineWidth = this.lineWidth;
		context.fillStyle = this.color;
		context.beginPath();
		//x, y, radius, start_angle, end_angle, anti-clockwise
		if (!this.fixed) context.arc(0, 0, this.radius, 0, (Math.PI * 2), true);
		context.closePath();
		context.fill();
		context.strokeStyle = "#FFF";
		context.stroke();
		context.restore();
		//if (!this.fixed) context.fillText(">" + this.coord , this.x, this.y); // test message*/
};
DragItem.prototype.draw_nav = function (context) {
		context.save();
		context.translate(this.x, this.y);
		context.rotate(this.rotation);
		context.scale(this.scaleX, this.scaleY);
		context.lineWidth = this.lineWidth;
		context.fillStyle = this.color;
		context.beginPath();
		//x, y, radius, start_angle, end_angle, anti-clockwise
		if (!this.fixed) context.arc(0, 0, this.radius, 0, (Math.PI * 2), true);
		context.closePath();
		context.fill();
		context.strokeStyle = "#FFF";
		context.stroke();
		context.restore();
		if (!this.fixed){
			context.font = '16pt Arial';
			context.fillStyle = 'white';
			if (this.id < 10)		context.fillText("    " + this.id , this.x - 30, this.y + 7); // test message*/
			else										context.fillText("   " + this.id , this.x - 30, this.y + 7); // test message*/
			
		}
}
// get boundries of image
DragItem.prototype.getBounds = function () {
  return {
    x: this.x - this.match,
    y: this.y - this.match,
    width: 100 + this.match,
    height: 50 + this.match
  };
};
// get mouse and make correct coordinations for drag
DragItem.prototype.correctBoundsXY = function (mouseXX, mouseYY) {
	this.distanceX = mouseXX - this.x;
	this.distanceY = mouseYY - this.y;
};
DragItem.prototype.getCorrectBounds = function (type) {
	if(type == 1)		return this.distanceX;
	else								return this.distanceY;
};
